Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# Deflator Class Reference

`#include <zdeflate.h>`

Inheritance diagram for Deflator:

List of all members.

## Detailed Description

DEFLATE (RFC 1951) compressor.

Definition at line 55 of file zdeflate.h.

## SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
virtual int | GetAutoSignalPropagation () const
## Public Types
enum | { MIN_DEFLATE_LEVEL = 0, DEFAULT_DEFLATE_LEVEL = 6, MAX_DEFLATE_LEVEL = 9 }
enum | { MIN_LOG2_WINDOW_SIZE = 9, DEFAULT_LOG2_WINDOW_SIZE = 15, MAX_LOG2_WINDOW_SIZE = 15 }
## Public Member Functions
| Deflator (BufferedTransformation *attachment=NULL, int deflateLevel=DEFAULT_DEFLATE_LEVEL, int log2WindowSize=DEFAULT_LOG2_WINDOW_SIZE, bool detectUncompressible=true)
| Deflator (const NameValuePairs &parameters, BufferedTransformation *attachment=NULL)
| possible parameter names: Log2WindowSize, DeflateLevel, DetectUncompressible
void | SetDeflateLevel (int deflateLevel)
| this function can be used to set the deflate level in the middle of compression
int | GetDeflateLevel () const
int | GetLog2WindowSize () const
void | IsolatedInitialize (const NameValuePairs &parameters)
unsigned int | Put2 (const byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
bool | IsolatedFlush (bool hardFlush, bool blocking)
void | PutBits (unsigned long value, unsigned int length)
void | FlushBitBuffer ()
void | ClearBitBuffer ()
void | StartCounting ()
unsigned long | FinishCounting ()
bool | Attachable ()
| returns whether this object allows attachment
BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
const BufferedTransformation * | AttachedTransformation () const
void | Detach (BufferedTransformation *newAttachment=NULL)
| delete the current attachment chain and replace it with newAttachment
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Types
enum | { STORED = 0, STATIC = 1, DYNAMIC = 2 }
enum | { MIN_MATCH = 3, MAX_MATCH = 258 }
## Protected Member Functions
virtual void | WritePrestreamHeader ()
virtual void | ProcessUncompressedData (const byte *string, unsigned int length)
virtual void | WritePoststreamTail ()
void | InitializeStaticEncoders ()
void | Reset (bool forceReset=false)
unsigned int | FillWindow (const byte *str, unsigned int length)
unsigned int | ComputeHash (const byte *str) const
unsigned int | LongestMatch (unsigned int &bestMatch) const
void | InsertString (unsigned int start)
void | ProcessBuffer ()
void | LiteralByte (byte b)
void | MatchFound (unsigned int distance, unsigned int length)
void | EncodeBlock (bool eof, unsigned int blockType)
void | EndBlock (bool eof)
virtual BufferedTransformation * | NewDefaultAttachment () const
void | Insert (Filter *nextFilter)
virtual bool | ShouldPropagateMessageEnd () const
virtual bool | ShouldPropagateMessageSeriesEnd () const
void | PropagateInitialize (const NameValuePairs &parameters, int propagation)
unsigned int | Output (int outputSite, const byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
unsigned int | OutputModifiable (int outputSite, byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputFlush (int outputSite, bool hardFlush, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageSeriesEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Protected Attributes
int | m_deflateLevel
int | m_log2WindowSize
int | m_compressibleDeflateLevel
unsigned int | m_detectSkip
unsigned int | m_detectCount
unsigned int | DSIZE
unsigned int | DMASK
unsigned int | HSIZE
unsigned int | HMASK
unsigned int | GOOD_MATCH
unsigned int | MAX_LAZYLENGTH
unsigned int | MAX_CHAIN_LENGTH
bool | m_headerWritten
bool | m_matchAvailable
unsigned int | m_dictionaryEnd
unsigned int | m_stringStart
unsigned int | m_lookahead
unsigned int | m_minLookahead
unsigned int | m_previousMatch
unsigned int | m_previousLength
HuffmanEncoder | m_staticLiteralEncoder
HuffmanEncoder | m_staticDistanceEncoder
HuffmanEncoder | m_dynamicLiteralEncoder
HuffmanEncoder | m_dynamicDistanceEncoder
SecByteBlock | m_byteBuffer
SecBlock< word16 > | m_head
SecBlock< word16 > | m_prev
FixedSizeSecBlock< unsigned int, 286 > | m_literalCounts
FixedSizeSecBlock< unsigned int, 30 > | m_distanceCounts
SecBlock< EncodedMatch > | m_matchBuffer
unsigned int | m_matchBufferEnd
unsigned int | m_blockStart
unsigned int | m_blockLength
bool | m_counting
unsigned long | m_bitCount
unsigned long | m_buffer
unsigned int | m_bitsBuffered
unsigned int | m_bytesBuffered
FixedSizeSecBlock< byte, 256 > | m_outputBuffer
unsigned int | m_inputPosition
int | m_continueAt

## Constructor & Destructor Documentation

Deflator::Deflator | ( | BufferedTransformation * | attachment = `NULL`,
|  | int | deflateLevel = `DEFAULT_DEFLATE_LEVEL`,
|  | int | log2WindowSize = `DEFAULT_LOG2_WINDOW_SIZE`,
|  | bool | detectUncompressible = `true`
| ) |

| Note: detectUncompressible makes it faster to process uncompressible files, but if a file has both compressible and uncompressible parts, it may fail to compress some of the compressible parts. Definition at line 213 of file zdeflate.cpp.

## Member Function Documentation

unsigned int Deflator::Put2 | ( | const byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[virtual]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Implements BufferedTransformation. Definition at line 477 of file zdeflate.cpp.

bool Filter::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented from BufferedTransformation. Definition at line 19 of file filters.h.

bool Filter::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  | hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented from BufferedTransformation. Reimplemented in SecretSharing, and InformationDispersal. Definition at line 68 of file filters.cpp.

bool Filter::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented from BufferedTransformation. Definition at line 82 of file filters.cpp.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 711 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

| request space which can be written into by the caller, and then used as input to Put() Note: The purpose of this method is to help avoid doing extra memory allocations. Reimplemented in MeterFilter, HashFilter, Redirector, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 730 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in MeterFilter, and FilterWithBufferedInput. Definition at line 748 of file cryptlib.h.

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transferred signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 788 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 247 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 336 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- zdeflate.h
- zdeflate.cpp